<script setup lang="ts">
import { onMounted } from 'vue'
import { nextTick, ref } from 'vue'
import type { User } from '@/types/User'
import type { VForm } from 'vuetify/components'
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'
import userService from '@/services/user'
import { useUserStore } from '@/stores/user'

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Email',
    value: 'email',
    key: 'email'
  },
  {
    title: 'FullName',
    value: 'fullName',
    key: 'fullName'
  },
  {
    title: 'Gender',
    value: 'gender',
    key: 'gender'
  },
  // {
  //   title: 'Roles',
  //   key: 'roles',
  //   value: (item: any | User) => item.roles.join(', ')
  // },
  { key: 'actions', sortable: false }
]

const userStore = useUserStore()
const loadingStore = useLoadingStore()
const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const refForm = ref<VForm | null>(null)

let editedIndex = -1
let lastId = 5

function onSubmit() {}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}

async function deleteItemConfirm() {
  await userStore.deleteUser()
  closeDelete()
}

async function editItem(item: User) {
  if (!item.id) return
  await userStore.getUser(item.id)
  dialog.value = true
}

// function deleteItem(item: User) {
//   editedIndex = users.value.indexOf(item)
//   editedUser.value = Object.assign({}, item)
//   dialogDelete.value = true
//   editedIndex = -1
// }
async function deleteItem(item: User) {
  if (!item.id) return
  await userStore.getUser(item.id)
  dialogDelete.value = true
  editedIndex = -1
}

onMounted(() => {
  userStore.getUsers()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await userStore.saveUser()
  closeDialog()
}

// function searchUser(name: string) {
//   if (name.trim() === '') {
//     userStore.getUsers()
//     return
//   }

//   const foundUsers = users.value.filter((user) =>
//     user.fullName.toLowerCase().includes(name.toLowerCase())
//   )
//   users.value = foundUsers
// }

// const name = ref('')
// function onClick() {
//   searchUser(name.value)
// }
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="userStore.users" class="custom-datatable">
      <template v-slot:top>
        <v-toolbar flat style="background-color: #4b382a">
          <v-toolbar-title style="color: white">User</v-toolbar-title>
          <!-- <v-text-field
            v-model="name"
            density="compact"
            variant="solo"
            label="Search Name"
            append-inner-icon="mdi-magnify"
            single-line
            hide-details
            @click:append-inner="onClick"
            @keyup.enter="onClick()"
          ></v-text-field> -->

          <v-btn icon="mdi-cached" style="color: white" @click="userStore.getUsers"></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>

          <v-spacer></v-spacer>

          <!-- Put Edited  Dialog -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
              >
                New User
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">User Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12">
                        <v-text-field
                          v-model="userStore.editedUser.fullName"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="userStore.editedUser.email"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Email"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="userStore.editedUser.password"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Password"
                          placeholder="Enter your password"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Gender"
                          :items="['Male', 'Female', 'Other']"
                          v-model="userStore.editedUser.gender"
                          variant="solo-filled"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="userStore.editedUser.roles"
                          :items="[
                            { title: 'Admin', value: 'admin' },
                            { title: 'User', value: 'user' }
                          ]"
                          label="Select roles"
                          multiple
                          :return-object="false"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this user?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="rgb(214, 175, 125)" @click="userStore.getUsers"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>

<style>
.custom-datatable {
  & th {
    background-color: rgba(174, 167, 160, 1);
    color: white;
    font-weight: bold;
  }
  & tbody tr:nth-child(even) {
    background-color: rgba(244, 238, 226, 1);
  }

  & tbody tr:nth-child(odd) {
    background-color: rgba(234, 227, 217, 1);
  }
}
</style>
